package com.astrum.vfaceapi;

import android.os.Bundle;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

import com.astrum.api.WebService;
import com.astrum.utils.HttpCore;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;

import java.util.HashMap;
import java.util.List;

public class MainActivity extends AppCompatActivity {
    WebService webService = null;
    String USER_NAME = "superuser";
    String PASSWORD = "astrum";
    Handler handler = new Handler();
    String allUnits = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        findViewById(R.id.btnLogin).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                String hostName = ((EditText) findViewById(R.id.txtHost)).getText().toString();
                findViewById(R.id.lyProgress).setVisibility(View.VISIBLE);
                webService = new WebService(hostName);
                webService.loginAsync(USER_NAME, PASSWORD, new HttpCore.ResponseListener<String>() {
                    @Override
                    public void onResponse(String response, HashMap<String, List<String>> headers) {
                        handler.post(new Runnable() {
                            @Override
                            public void run() {
                                findViewById(R.id.btnGetAllUnits).setEnabled(true);
                                findViewById(R.id.btnGetUnitForSection).setEnabled(false);
                                findViewById(R.id.btnSetUnit).setEnabled(false);
                                findViewById(R.id.btnGetUnit).setEnabled(false);
                                findViewById(R.id.lyProgress).setVisibility(View.GONE);
                                ((TextView) findViewById(R.id.txtResult)).setText("Login Success");
                            }
                        });
                    }

                    @Override
                    public void onError(int statusCode, HashMap<String, List<String>> headers) {
                        handler.post(new Runnable() {
                            @Override
                            public void run() {
                                findViewById(R.id.btnGetAllUnits).setEnabled(false);
                                findViewById(R.id.btnGetUnitForSection).setEnabled(false);
                                findViewById(R.id.btnSetUnit).setEnabled(false);
                                findViewById(R.id.btnGetUnit).setEnabled(false);
                                findViewById(R.id.lyProgress).setVisibility(View.GONE);
                                ((TextView) findViewById(R.id.txtResult)).setText("Login Error");
                            }
                        });

                    }
                });
            }
        });
        findViewById(R.id.btnGetAllUnits).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                findViewById(R.id.lyProgress).setVisibility(View.VISIBLE);
                webService.getAllUnitsAsync(new HttpCore.ResponseListener<String>() {
                    @Override
                    public void onResponse(final String response, HashMap<String, List<String>> headers) {
                        allUnits = response;
                        handler.post(new Runnable() {
                            @Override
                            public void run() {
                                ((TextView) findViewById(R.id.txtResult)).setText(response);
                                handler.post(new Runnable() {
                                    @Override
                                    public void run() {
                                        findViewById(R.id.btnGetUnitForSection).setEnabled(true);
                                        findViewById(R.id.btnSetUnit).setEnabled(true);
                                        findViewById(R.id.btnGetUnit).setEnabled(true);
                                        findViewById(R.id.lyProgress).setVisibility(View.GONE);
                                        ((TextView) findViewById(R.id.txtResult)).setText(response);
                                    }
                                });
                            }
                        });
                    }

                    @Override
                    public void onError(int statusCode, HashMap<String, List<String>> headers) {
                        handler.post(new Runnable() {
                            @Override
                            public void run() {
                                handler.post(new Runnable() {
                                    @Override
                                    public void run() {
                                        findViewById(R.id.btnGetUnitForSection).setEnabled(false);
                                        findViewById(R.id.btnSetUnit).setEnabled(false);
                                        findViewById(R.id.btnGetUnit).setEnabled(false);
                                        findViewById(R.id.lyProgress).setVisibility(View.GONE);
                                        ((TextView) findViewById(R.id.txtResult)).setText("Get All Units Error");
                                    }
                                });
                            }
                        });
                    }
                });
            }
        });
        findViewById(R.id.btnGetUnitForSection).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                JSONArray json;
                String sectionId = null;
                try {
                    json = (JSONArray) (new JSONParser()).parse(allUnits);
                    JSONObject firstSection = (JSONObject) json.get(0);
                    sectionId = firstSection.get("uniqueId").toString();

                    webService.getUnitsForSectionAsync(WebService.UnitType.INDOOR, sectionId, new HttpCore.ResponseListener<String>() {
                        @Override
                        public void onResponse(final String response, HashMap<String, List<String>> headers) {
                            handler.post(new Runnable() {
                                @Override
                                public void run() {
                                    ((TextView) findViewById(R.id.txtResult)).setText(response);
                                    handler.post(new Runnable() {
                                        @Override
                                        public void run() {
                                            findViewById(R.id.btnSetUnit).setEnabled(true);
                                            findViewById(R.id.btnGetUnit).setEnabled(true);
                                            findViewById(R.id.lyProgress).setVisibility(View.GONE);
                                            ((TextView) findViewById(R.id.txtResult)).setText(response);
                                        }
                                    });
                                }
                            });
                        }

                        @Override
                        public void onError(int statusCode, HashMap<String, List<String>> headers) {
                            handler.post(new Runnable() {
                                @Override
                                public void run() {
                                    handler.post(new Runnable() {
                                        @Override
                                        public void run() {
                                            findViewById(R.id.btnSetUnit).setEnabled(false);
                                            findViewById(R.id.btnGetUnit).setEnabled(false);
                                            findViewById(R.id.lyProgress).setVisibility(View.GONE);
                                            ((TextView) findViewById(R.id.txtResult)).setText("Get All Units Error");
                                        }
                                    });
                                }
                            });
                        }
                    });
                } catch (Exception e) {
                    e.printStackTrace();
                    ((TextView) findViewById(R.id.txtResult)).setText(e.toString());
                    return;
                }
            }
        });
        findViewById(R.id.btnGetUnit).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                JSONArray json;
                String unitId;
                String channel;
                WebService.UnitType unitType;
                try {
                    json = (JSONArray) (new JSONParser()).parse(allUnits);
                    JSONObject firstSection = (JSONObject) json.get(0);
                    JSONArray units = (JSONArray) firstSection.get("units");
                    JSONObject unit = (JSONObject) units.get(0);
                    unitId = unit.get("uid").toString();
                    channel = unit.get("channel").toString();
                    unitType = WebService.UnitType.valueOf(unit.get("unitType").toString());
                    findViewById(R.id.lyProgress).setVisibility(View.VISIBLE);
                    webService.getUnitAsync(unitId, unitType, channel, new HttpCore.ResponseListener<String>() {
                        @Override
                        public void onResponse(final String response, HashMap<String, List<String>> headers) {
                            handler.post(new Runnable() {
                                @Override
                                public void run() {
                                    ((TextView) findViewById(R.id.txtResult)).setText(response);
                                    handler.post(new Runnable() {
                                        @Override
                                        public void run() {
                                            findViewById(R.id.lyProgress).setVisibility(View.GONE);
                                            ((TextView) findViewById(R.id.txtResult)).setText(response);
                                        }
                                    });
                                }
                            });
                        }

                        @Override
                        public void onError(int statusCode, HashMap<String, List<String>> headers) {
                            handler.post(new Runnable() {
                                @Override
                                public void run() {
                                    handler.post(new Runnable() {
                                        @Override
                                        public void run() {
                                            findViewById(R.id.lyProgress).setVisibility(View.GONE);
                                            ((TextView) findViewById(R.id.txtResult)).setText("Get All Units Error");
                                        }
                                    });
                                }
                            });
                        }
                    });
                } catch (Exception e) {
                    e.printStackTrace();
                    ((TextView) findViewById(R.id.txtResult)).setText(e.toString());
                    return;
                }
            }

        });
        findViewById(R.id.btnSetUnit).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                JSONArray json;
                String unitId;
                String channel;
                try {
                    json = (JSONArray) (new JSONParser()).parse(allUnits);
                    JSONObject firstSection = (JSONObject) json.get(0);
                    JSONArray units = (JSONArray) firstSection.get("units");
                    JSONObject unit = (JSONObject) units.get(0);
                    unitId = unit.get("uniqueId").toString();
                    channel = unit.get("channel").toString();

                    JSONObject setUnitValue = new JSONObject();
                    setUnitValue.put("channel", channel);//value CHANNEL_1,CHANNEL_2
                    setUnitValue.put("fanValue", "Low");//value Low,Med,High,Auto
                    setUnitValue.put("modValue", "Dry");//value Cool,Heat,Fan,Auto,Dry
                    setUnitValue.put("onOff", true);//value true,false
                    setUnitValue.put("setTemp", 26);//value 16-32
                    setUnitValue.put("swing", 1);//value:1,0
                    setUnitValue.put("uniqueId", unitId);


                    findViewById(R.id.lyProgress).setVisibility(View.VISIBLE);
                    webService.setUnitAsync(setUnitValue, new HttpCore.ResponseListener<String>() {
                        @Override
                        public void onResponse(final String response, HashMap<String, List<String>> headers) {
                            handler.post(new Runnable() {
                                @Override
                                public void run() {
                                    ((TextView) findViewById(R.id.txtResult)).setText(response);
                                    handler.post(new Runnable() {
                                        @Override
                                        public void run() {
                                            findViewById(R.id.lyProgress).setVisibility(View.GONE);
                                            ((TextView) findViewById(R.id.txtResult)).setText(response);
                                        }
                                    });
                                }
                            });
                        }

                        @Override
                        public void onError(int statusCode, HashMap<String, List<String>> headers) {
                            handler.post(new Runnable() {
                                @Override
                                public void run() {
                                    handler.post(new Runnable() {
                                        @Override
                                        public void run() {
                                            findViewById(R.id.lyProgress).setVisibility(View.GONE);
                                            ((TextView) findViewById(R.id.txtResult)).setText("Set unit Error");
                                        }
                                    });
                                }
                            });
                        }
                    });

                } catch (Exception e) {
                    e.printStackTrace();
                    ((TextView) findViewById(R.id.txtResult)).setText(e.toString());
                    return;
                }

            }
        });
    }
}
