package com.astrum.api;


import com.astrum.utils.HttpCore;

import org.json.simple.JSONObject;

import java.util.HashMap;
import java.util.List;

/**
 * Created by ebicer on 1/20/17.
 */

public class WebService {
    String COOKIE;
    String HOST_NAME;



    public enum UnitType{
        INDOOR,
        OUTDOOR
    }
    public WebService (String host){
        HOST_NAME = host;
    }

    private void getRequest(String url, HttpCore.ResponseListener<String> responseListener) {
        HashMap<String, String> headers = new HashMap<>();
        headers.put("Cookie", COOKIE);
        HttpCore.getJSON(HOST_NAME + url, headers, String.class, responseListener);
    }

    private void getRequestAsync(String url, HttpCore.ResponseListener<String> responseListener) {
        HashMap<String, String> headers = new HashMap<>();
        headers.put("Cookie", COOKIE);
        HttpCore.getJSONAsync(HOST_NAME + url, headers, String.class, responseListener);
    }

    private void postRequest(String url, String value, HttpCore.ResponseListener<String> responseListener) {
        HashMap<String, String> headers = new HashMap<>();
        headers.put("Cookie", COOKIE);
        HttpCore.postJSON(HOST_NAME + url, value, headers, String.class, responseListener);
    }

    private void postRequestAsync(String url, String value, HttpCore.ResponseListener<String> responseListener) {
        HashMap<String, String> headers = new HashMap<>();
        headers.put("Cookie", COOKIE);
        HttpCore.postJSONAsync(HOST_NAME + url, value, headers, String.class, responseListener);
    }
    public void login(String userName,String password,final HttpCore.ResponseListener<String> responseListener) {
        HttpCore.getJSON(HOST_NAME + "/service/login?userName="+userName+"&password="+password, null, String.class, new HttpCore.ResponseListener<String>() {
            @Override
            public void onResponse(String response, HashMap headers) {
                List<String> Cookie = (List<String>) headers.get("Set-Cookie");
                COOKIE = Cookie.get(0);
                if(responseListener!=null){
                    responseListener.onResponse(response, headers);
                }

            }

            @Override
            public void onError(int statusCode, HashMap<String, List<String>> headers) {
                if(responseListener!=null) {
                    responseListener.onError(statusCode, null);
                }
            }
        });
    }
    public void loginAsync(String userName,String password,final HttpCore.ResponseListener<String> responseListener) {
        HttpCore.getJSONAsync(HOST_NAME + "/service/login?userName="+userName+"&password="+password, null, String.class, new HttpCore.ResponseListener<String>() {
            @Override
            public void onResponse(String response, HashMap headers) {
                List<String> Cookie = (List<String>) headers.get("Set-Cookie");
                COOKIE = Cookie.get(0);
                if(responseListener!=null){
                    responseListener.onResponse(response, headers);
                }

            }

            @Override
            public void onError(int statusCode, HashMap<String, List<String>> headers) {
                if(responseListener!=null) {
                    responseListener.onError(statusCode, null);
                }
            }
        });
    }

    public void getUnitsForSection(UnitType unitType, String sectionId, HttpCore.ResponseListener<String> responseListener) {
        String filter = "UnitType="+unitType.name();
        if (sectionId != null) {
            filter = "SectionId=" + sectionId + "&" + filter;
        }
        getRequest("/service/getsectionunits?" + filter, responseListener);
    }
    public void getAllUnits(HttpCore.ResponseListener<String> responseListener) {
        getRequest("/service/getsections", responseListener);
    }
    public void getUnit(String unitId,UnitType unitType, String channel, HttpCore.ResponseListener<String> responseListener) {
        getRequest("/service/getunit?UnitId="+unitId+"&Channel="+channel+"&UnitType="+unitType.name(), responseListener);
    }
    public void setUnit(JSONObject unit,HttpCore.ResponseListener<String> responseListener){
        postRequest("/service/setunit", unit.toJSONString(), responseListener);
    }
    public void getUnitsForSectionAsync(UnitType unitType, String sectionId, HttpCore.ResponseListener<String> responseListener) {
        String filter = "UnitType="+unitType.name();
        if (sectionId != null) {
            filter = "SectionId=" + sectionId + "&" + filter;
        }
        getRequestAsync("/service/getsectionunits?" + filter, responseListener);
    }
    public void getAllUnitsAsync(HttpCore.ResponseListener<String> responseListener) {
        getRequestAsync("/service/getsections", responseListener);
    }

    public void getUnitAsync(String unitId,UnitType unitType, String channel, HttpCore.ResponseListener<String> responseListener) {
        getRequestAsync("/service/getunit?UnitId="+unitId+"&Channel="+channel+"&UnitType="+unitType.name(), responseListener);
    }
    public void setUnitAsync(JSONObject unit,HttpCore.ResponseListener<String> responseListener){
        postRequestAsync("/service/setunit", unit.toJSONString(), responseListener);
    }

}
